/*
C*GRBPIC -- begin picture
C+
      SUBROUTINE GRBPIC
C
C GRPCKG (internal routine). Send a "begin picture" command to the
C device driver, and send commands to set deferred attributes (color,
C line width, etc.)
C-----------------------------------------------------------------------
*/

#include <math.h>
#include "pgplot.h"
#define TRUE 1

void grbpic_() {
	char chr[20];
	int lchr, nbuf;
	float rbuf[2];
	int IFUNC;
	int cgrcide = grcm00_.grcide - 1;

	grcm00_.grpltd[cgrcide] = TRUE;
	if (grcm00_.grgtyp > 0) {
/*         -- begin picture */
		rbuf[0] = (float) grcm00_.grxmxa[cgrcide];
		rbuf[1] = (float) grcm00_.grymxa[cgrcide];
		nbuf = 2;
		IFUNC = 11;
		grexec_(&grcm00_.grgtyp, &IFUNC, rbuf, &nbuf, chr, &lchr, 20);
/*         -- set color index */
		rbuf[0] = (float) grcm00_.grccol[cgrcide];
		nbuf = 1;
		IFUNC = 15;
		grexec_(&grcm00_.grgtyp, &IFUNC, rbuf, &nbuf, chr, &lchr, 20);
/*         -- set line width */
		if (*(unsigned char *)&grcm01_.grgcap[cgrcide * 11 + 4] == 'T') {
			rbuf[0] = fabs((float)(grcm00_.grwidt[cgrcide]));
	    nbuf = 1;
			IFUNC = 22;
	    grexec_(&grcm00_.grgtyp, &IFUNC, rbuf, &nbuf, chr, &lchr, 20);
		}
/*         -- set hardware dashing */
		if (*(unsigned char *)&grcm01_.grgcap[cgrcide * 11 + 2] == 'D') {
			rbuf[0] = (float) grcm00_.grstyl[cgrcide];
			nbuf = 1;
			IFUNC = 19;
	    grexec_(&grcm00_.grgtyp, &IFUNC, rbuf, &nbuf, chr, &lchr, 20);
		}
	}
}


