/* grimg1.f -- translated by f2c (version 20090411).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include <math.h>
#include "pgplot.h"

/* Table of constant values */

static integer c__26 = 26;

/* *GRIMG1 -- image of a 2D data array (image-primitive devices) */
/* + */
/* Subroutine */ void grimg1_(real *a, integer *idim, integer *jdim, integer *
	i1, integer *i2, integer *j1, integer *j2, real *a1, real *a2, real *
	pa, integer *minind, integer *maxind, integer *mode)
{
    /* System generated locals */
    integer a_dim1, a_offset, i__1, i__2;
    real r__1, r__2;

    /* Local variables */
    static integer i__, j, ii;
    static real av;
    static integer iv;
    static real fac;
    static char chr[1];
    static integer nxp, nyp, lchr, nbuf;
    static real rbuf[21], sfacl;


/* (This routine is called by GRIMG0.) */
/* -- */
/* 7-Sep-1994  New routine [TJP]. */
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */


/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */


/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/* Size of image. */

    /* Parameter adjustments */
    a_dim1 = *idim;
    a_offset = 1 + a_dim1;
    a -= a_offset;
    --pa;

    /* Function Body */
    nxp = *i2 - *i1 + 1;
    nyp = *j2 - *j1 + 1;
    rbuf[0] = 0.f;
    rbuf[1] = (real) nxp;
    rbuf[2] = (real) nyp;

/* Clipping rectangle. */

    rbuf[3] = grcm00_.grxmin[grcm00_.grcide - 1];
    rbuf[4] = grcm00_.grxmax[grcm00_.grcide - 1];
    rbuf[5] = grcm00_.grymin[grcm00_.grcide - 1];
    rbuf[6] = grcm00_.grymax[grcm00_.grcide - 1];

/* Image transformation matrix. */

    fac = pa[2] * pa[6] - pa[3] * pa[5];
    rbuf[7] = pa[6] / fac;
    rbuf[8] = -pa[5] / fac;
    rbuf[9] = -pa[3] / fac;
    rbuf[10] = pa[2] / fac;
    rbuf[11] = (pa[3] * pa[4] - pa[1] * pa[6]) / fac - (*i1 - .5f);
    rbuf[12] = (pa[5] * pa[1] - pa[4] * pa[2]) / fac - (*j1 - .5f);

/* Send setup info to driver. */

    if (! grcm00_.grpltd[grcm00_.grcide - 1]) {
	grbpic_();
    }
    grterm_();
    nbuf = 13;
    lchr = 0;
    grexec_(&grcm00_.grgtyp, &c__26, rbuf, &nbuf, chr, &lchr, (ftnlen)1);

/* Convert image array to color indices and send to driver. */

    sfacl = log(65001.f);
    ii = 0;
    i__1 = *j2;
    for (j = *j1; j <= i__1; ++j) {
	i__2 = *i2;
	for (i__ = *i1; i__ <= i__2; ++i__) {
	    av = a[i__ + j * a_dim1];
	    if (*a2 > *a1) {
/* Computing MIN */
				if (av < *a1) av = *a1;
				if (av > *a2) av = *a2;
	    } else {
/* Computing MIN */
				if (av < *a2) av = *a2;
				if (av > *a1) av = *a1;
	    }
	    if (*mode == 0) {
		r__1 = (*minind * (*a2 - av) + *maxind * (av - *a1)) / (*a2 - 
			*a1);
		iv = (int)(r__1 + 0.5);
	    } else if (*mode == 1) {
		r__2 = (*maxind - *minind) * log((r__1 = (av - *a1) / (*a2 - *
			a1), fabs(r__1)) * 6.5e4f + 1.f) / sfacl;
		iv = *minind + (int)(r__2 + 0.5);
	    } else if (*mode == 2) {
		r__2 = (*maxind - *minind) * sqrt((r__1 = (av - *a1) / (*a2 - 
			*a1), fabs(r__1)));
		iv = *minind + (int)(r__2 + 0.5);
	    } else {
		iv = *minind;
	    }
	    ++ii;
	    rbuf[ii] = (real) iv;
	    if (ii == 20) {
		nbuf = ii + 1;
		rbuf[0] = (real) ii;
		grexec_(&grcm00_.grgtyp, &c__26, rbuf, &nbuf, chr, &lchr, (
			ftnlen)1);
		ii = 0;
	    }
/* L10: */
	}
/* L20: */
    }
    if (ii > 0) {
	nbuf = ii + 1;
	rbuf[0] = (real) ii;
	grexec_(&grcm00_.grgtyp, &c__26, rbuf, &nbuf, chr, &lchr, (ftnlen)1);
	ii = 0;
    }

/* Send termination code to driver. */

    nbuf = 1;
    rbuf[0] = -1.f;
    grexec_(&grcm00_.grgtyp, &c__26, rbuf, &nbuf, chr, &lchr, (ftnlen)1);
/* ----------------------------------------------------------------------- */
} /* grimg1_ */

